unit IdentReader;

interface

uses
  Classes, SynaSer, windows;

type
  TIdentReader = class(TThread)
  private
  protected
    procedure Execute; override;
    procedure ProcessBar;
  public
    ComPort: string;
    Ser: TBlockSerial;
    FailCode: integer;
    FailString: string;
    BarCode: string;
    Reply: string;
    Constructor Create(const Port: string);
    Destructor Destroy; override;
  end;

implementation

uses
  unit1;

Constructor TIdentReader.Create(const Port: string);
begin
  inherited Create(true);
  FreeOnTerminate:=false;
  Priority:=tpNormal;
  Ser:=TBlockSerial.Create;
  ComPort := Port;
  FailCode :=0;
  FailString := '';
  ser.Connect(Comport, 9600, 8, 'N', 0, false, false);
  FailCode := ser.LastError;
  Failstring := ser.LastErrorDesc;
  resume;
end;

Destructor TIdentReader.Destroy;
begin
  Ser.Free;
end;

procedure TIdentReader.ProcessBar;
begin
  Reply := form1.ProcessBarCode(barCode);
end;

procedure TIdentReader.Execute;
begin
  while not terminated do
  begin
    barCode := ser.RecvTerminated(1000,#$0d);
    if barCode <> '' then
    begin
      Synchronize(Processbar);
      ser.SendString(#$1b+Reply+#$0d);
    end;
  end;
end;

end.
